//06-mar-2007 20:20:00

typedef unsigned short ushort;
typedef unsigned long  ulong;
typedef unsigned char  uchar;

uchar dataa[]="01-ian-2007";
uchar  oraa[]="00:00:00";

#include "aplic.h"
#include "savalin.h"
#define DEF_FURNIZORI
#include "struct.h"

void adaugari(void);
void modificari(void);
void stergeri(void);
void editare(void);
void terminare(void);
void ecran(uchar *mesaj);
void recodificare(void);

ulong intreg;
ushort i,j,sec,dela,pnla;
uchar tip_act,SW,den[30],alfa[20];
ulong contv,contn;

struct TAB
{
	uchar  den[30];
	ushort pozitia;
} *p,*q;

int fc(void)
{
	PUN(TAB)
	return strnicmp((uchar *)A->den,(uchar *)B->den,30);
}

int main(int _argc,uchar *_argv[])
{
	if(_argc-3)
	{
		printf("Intrati cu procedura.");abo();
	}
	sprintf(man,"%2.2s",_argv[_argc-1]+8);
	margine_stanga=atoi(man);
	sprintf(man,"%1.1s",_argv[_argc-1]+10);
	tip_prn=atoi(man);
	sprintf(pathd,"%s",_argv[_argc-1]+11);
	lg_pathd=strlen(pathd);
	ALLOC();
	prez("A C T N O M F","Actualizare NOMENCLATOR FURNIZORI");
	strncpy(nume_ant+4,_argv[_argc-1],4);
	RCSANT=sizeof(antet);
	if((nfant=Open(pathd,nume_ant,O_BINARY|O_RDONLY))<1)
	{
		printf("\nFisier %s absent.",nume_ant);abo();
	}
	nartf=filelength(nfant);
	if(nartf&&nartf<RCSANT) RCSANT=nartf;
	if(nartf!=RCSANT)
	{
		printf("\nFisier %s incoerent.",nume_ant);abo();
	}
	READ(nfant,&antet,RCSANT);
	CLOSE(nfant);
	for(i=lg_pathd-1;i;i--) if(pathd[i-1]=='\\'||pathd[i-1]=='/') break;
	for(j=i-1;j;j--) if(pathd[j-1]=='\\'||pathd[j-1]=='/') break;
	strncpy(nume_nomf+4,_argv[_argc-1],4);
	strncpy(nume_nomf,_argv[_argc-1]+6,2);
	RCSF=sizeof(artf);
	if((nff=Open(pathd,nume_nomf,O_BINARY|O_RDWR))<1)
	{
		printf("\nFisier %s absent. Se creeaza (D,N):",
		nume_nomf);ix=wherex();iy=wherey();
		while(true)
		{
			gotoxy(ix,iy);printf(" ");gotoxy(ix,iy);
			if(citire_text(1,man)) GRESIT
			strupr(man);
			if(man[0]=='N') exit(0);
			if(man[0]!='D') GRESIT
			break;
		}
		if((nff=Open(pathd,nume_nomf,FA_ARCH))<1)
		{
			printf("\nFisierul %s nu poate fi creat.",
			nume_nomf);abo();
		}
	}
	if((nartf=filelength(nff))%RCSF)
	{
		printf("\nFisier %s incoerent.",nume_nomf);
		abo();
	}
	nartf/=RCSF;
	qnf=pnf=(struct TABF *)O;
	printf("\n%s citire:%lu/",nume_nomf,nartf);
	ix=wherex();iy=wherey();
	for(i=0;i<nartf;i++)
	{
		if(i%10==0) {gotoxy(ix,iy);printf("%u",i);}
		READ(nff,&artf,RCSF);
		pnf->cod=artf.cod;
		pnf->pozitia=i;
		pnf++;
	}
	gotoxy(ix,iy);printf("%lu Sortare",nartf);
	sort(fcnf,(uchar *)qnf,nartf,sizeof(*qnf));
	SW=0;
	while(true)
	{
		printf("\nA=Adaugari    M=Modificari");
		printf("\nS=Stergeri    E=Editare");
		printf("\nR=Recod.cont  T=Terminare");
		printf("\nFunctie (A,M,S,E,R,T):");
		ix=wherex();iy=wherey();
		while(true)
		{
			gotoxy(ix,iy);printf(" ");gotoxy(ix,iy);
			if(citire_text(1,man)) GRESIT
			strupr(man);
			tip_act=man[0];
			if(tip_act=='A') {adaugari();clrscr();break;}
			if(tip_act=='M') {modificari();clrscr();break;}
			if(tip_act=='S') {stergeri();clrscr();break;}
			if(tip_act=='E') {editare();break;}
			if(tip_act=='R') {recodificare();break;}
			if(tip_act=='T') {terminare();exit(0);}
			GRESIT
		}
	}
	return 0;
}

void adaugari(void)
{
	ushort cod;
	ecran("ADAUGARI");
	memset(&artf,' ',(int)RCSF);
	artf.cod=0;
	artf.sw_intern=1;
	artf.cod_selectie=0;
	artf.cont=401;
	if(nartf)
	{
		pnf=qnf+nartf-1;
		LSEEK(nff,pnf->pozitia*RCSF,SEEK_SET);
		READ(nff,&artf,RCSF);
	}
	cod=artf.cod+1;
	nr=0;
	while(true)
	{
		if(nr==0)
		{
			gotoxy(16,6);printf("%-5u",cod);gotoxy(16,6);
			i=citire_numar(5,0,0,man);
			if(i==END) return;
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",cod);
				i=0;
			}
			if(i) GRESIT
			intreg=atol(man);
			if(!intreg||intreg>0xFFFE) GRESIT
			i=intreg;
			caut_furn(i);
			if(GASIT)
			{
				eroare("Furnizor existent");
				continue;
			}
			artf.cod=i;
			gotoxy(16,6);printf("%-5u",artf.cod);
			nr++;
		}
		if(nr==1)
		{
			gotoxy(16,8);printf("%30.30s",artf.den);gotoxy(16,8);
			i=cit_text(30,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%30.30s",artf.den);i=0;
			}
			if(i) GRESIT
			if((man[0]=toupper(man[0]))==' ') GRESIT
			i=strlen(man);
			while(i<30) man[i++]=' ';
			strncpy(artf.den,man,30);
			gotoxy(16,8);printf("%30.30s",artf.den);
			nr++;
		}
		if(nr==2)
		{
			gotoxy(16,10);printf("%22.22s",artf.localitate);gotoxy(16,10);
			i=cit_text(22,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%22.22s",artf.localitate);i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			i=strlen(man);
			while(i<22) man[i++]=' ';
			if(man[0]==' ')
			{
				for(i=1;i<22;i++) if(man[i]!=' ') break;
				if(i<22) GRESIT
			}
			strncpy(artf.localitate,man,22);
			gotoxy(16,10);printf("%22.22s",artf.localitate);
			nr++;
		}
		if(nr==3)
		{
			gotoxy(16,12);printf("%13.13s",artf.cod_fiscal);gotoxy(16,12);
			i=cit_text(13,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%13.13s",artf.cod_fiscal);i=0;
			}
			if(i) GRESIT
			i=strlen(man);
			while(i<13) man[i++]=' ';
			if(man[0]==' ')
			{
				for(i=1;i<13;i++) if(man[i]!=' ') break;
				if(i<13) GRESIT
			}
			else
			{
				for(i=1;i<13;i++) if(man[i]!=' '&&man[i-1]==' ') break;
				if(i<13) GRESIT
			}
			strncpy(artf.cod_fiscal,man,13);
			gotoxy(16,12);printf("%13.13s",artf.cod_fiscal);
			nr++;
		}
		if(nr==4)
		{
			gotoxy(16,14);printf("%u",artf.sw_intern);gotoxy(16,14);
			i=citire_numar(1,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artf.sw_intern);
				i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i<1||i>3) GRESIT
			artf.sw_intern=i;
			nr++;
		}
		if(nr==5)
		{
			gotoxy(16,16);printf("%-3u",artf.cod_selectie);gotoxy(16,16);
			i=citire_numar(3,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artf.cod_selectie);
				i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i>0xFF) GRESIT
			artf.cod_selectie=i;
			nr++;
		}
		if(nr==6)
		{
			gotoxy(16,18);printf("%-9lu",artf.cont);gotoxy(16,18);
			i=citire_numar(9,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%lu",artf.cont);
				i=0;
			}
			if(i) GRESIT
			intreg=atol(man);
			if(!intreg) GRESIT
			artf.cont=intreg;
			nr++;
		}
		if(nr==7)
		{
			SW=1;
			if(nartf&&!qnf->cod)
			{
				qnf->cod=artf.cod;
				sec=qnf->pozitia;
				pnf=qnf+nartf;
				mut_mic(fcnf,(uchar *)qnf,(uchar *)pnf,nartf,sizeof(*qnf));
			}
			else
			{
				sec=nartf;
				pnf=qnf+nartf;
				pnf->cod=artf.cod;
				pnf->pozitia=sec;
				pnf++;nartf++;
				mut_mare(fcnf,(uchar *)qnf,(uchar *)pnf,nartf,sizeof(*qnf));
			}
			LSEEK(nff,sec*RCSF,SEEK_SET);
			artf.cod_sortare=0;
			WRITE(nff,&artf,RCSF);
			CLOSE(nff);
			nff=Open(pathd,nume_nomf,O_BINARY|O_RDWR);
			cod=artf.cod+1;
			nr=0;
		}
	}
}

void modificari(void)
{
	if(!nartf) return;
	pnf=qnf+nartf-1;
	if(!pnf->cod) return;
	ecran("MODIFICARI");
	LSEEK(nff,pnf->pozitia*RCSF,SEEK_SET);
	READ(nff,&artf,RCSF);
	nr=0;
	while(true)
	{
		if(nr==0)
		{
			gotoxy(16,6);printf("%-5u",artf.cod);gotoxy(16,6);
			i=citire_numar(5,0,0,man);
			if(i==END) return;
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artf.cod);
				i=0;
			}
			if(i) GRESIT
			intreg=atol(man);
			if(!intreg||intreg>0xFFFE) GRESIT
			i=intreg;
			caut_furn(i);
			if(NEGASIT)
			{
				eroare("Furnizor inexistent");
				continue;
			}
			artf.cod=i;
			gotoxy(16,6);printf("%-5u",artf.cod);
			LSEEK(nff,pnf->pozitia*RCSF,SEEK_SET);
			READ(nff,&artf,RCSF);
			LSEEK(nff,-RCSF,SEEK_CUR);
			gotoxy(16,8);printf("%30.30s",artf.den);
			gotoxy(16,10);printf("%22.22s",artf.localitate);
			gotoxy(16,12);printf("%13.13s",artf.cod_fiscal);
			gotoxy(16,14);printf("%u",artf.sw_intern);
			gotoxy(16,16);printf("%-3u",artf.cod_selectie);
			gotoxy(16,18);printf("%-9lu",artf.cont);
			strncpy(den,artf.den,30);
			nr++;
		}
		if(nr==1)
		{
			gotoxy(16,8);printf("%30.30s",artf.den);gotoxy(16,8);
			i=cit_text(30,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%30.30s",artf.den);i=0;
			}
			if(i) GRESIT
			if((man[0]=toupper(man[0]))==' ') GRESIT
			i=strlen(man);
			while(i<30) man[i++]=' ';
			strncpy(artf.den,man,30);
			gotoxy(16,8);printf("%30.30s",artf.den);
			nr++;
		}
		if(nr==2)
		{
			gotoxy(16,10);printf("%22.22s",artf.localitate);gotoxy(16,10);
			i=cit_text(22,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%22.22s",artf.localitate);i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			i=strlen(man);
			while(i<22) man[i++]=' ';
			if(man[0]==' ')
			{
				for(i=1;i<22;i++) if(man[i]!=' ') break;
				if(i<22) GRESIT
			}
			strncpy(artf.localitate,man,22);
			gotoxy(16,10);printf("%22.22s",artf.localitate);
			nr++;
		}
		if(nr==3)
		{
			gotoxy(16,12);printf("%13.13s",artf.cod_fiscal);gotoxy(16,12);
			i=cit_text(13,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%13.13s",artf.cod_fiscal);i=0;
			}
			if(i) GRESIT
			i=strlen(man);
			while(i<13) man[i++]=' ';
			if(man[0]==' ')
			{
				for(i=1;i<13;i++) if(man[i]!=' ') break;
				if(i<13) GRESIT
			}
			else
			{
				for(i=1;i<13;i++) if(man[i]!=' '&&man[i-1]==' ') break;
				if(i<13) GRESIT
			}
			strncpy(artf.cod_fiscal,man,13);
			gotoxy(16,12);printf("%13.13s",artf.cod_fiscal);
			nr++;
		}
		if(nr==4)
		{
			gotoxy(16,14);printf("%u",artf.sw_intern);gotoxy(16,14);
			i=citire_numar(1,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artf.sw_intern);
				i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i<1||i>3) GRESIT
			artf.sw_intern=i;
			nr++;
		}
		if(nr==5)
		{
			gotoxy(16,16);printf("%-3u",artf.cod_selectie);gotoxy(16,16);
			i=citire_numar(3,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artf.cod_selectie);
				i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i>0xFF) GRESIT
			artf.cod_selectie=i;
			nr++;
		}
		if(nr==6)
		{
			gotoxy(16,18);printf("%-9lu",artf.cont);gotoxy(16,18);
			i=citire_numar(9,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%lu",artf.cont);
				i=0;
			}
			if(i) GRESIT
			intreg=atol(man);
			if(!intreg) GRESIT
			artf.cont=intreg;
			nr++;
		}
		if(nr==7)
		{
			if(strnicmp(den,artf.den,30))
			{
				SW=1;
				artf.cod_sortare=0;
			}
			WRITE(nff,&artf,RCSF);
			CLOSE(nff);
			nff=Open(pathd,nume_nomf,O_BINARY|O_RDWR);
			nr=0;
		}
	}
}

void stergeri(void)
{
	if(!nartf) return;
	pnf=qnf+nartf-1;
	if(!pnf->cod) return;
	ecran("STERGERI");
	LSEEK(nff,pnf->pozitia*RCSF,SEEK_SET);
	READ(nff,&artf,RCSF);
	nr=0;
	while(true)
	{
		if(nr==0)
		{
			gotoxy(16,6);printf("%-5u",artf.cod);gotoxy(16,6);
			i=citire_numar(5,0,0,man);
			if(i==END) return;
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artf.cod);
				i=0;
			}
			if(i) GRESIT
			intreg=atol(man);
			if(!intreg||intreg>0xFFFE) GRESIT
			i=intreg;
			caut_furn(i);
			if(NEGASIT)
			{
				eroare("Furnizor inexistent");
				continue;
			}
			artf.cod=i;
			gotoxy(16,6);printf("%-5u",artf.cod);
			LSEEK(nff,pnf->pozitia*RCSF,SEEK_SET);
			READ(nff,&artf,RCSF);
			LSEEK(nff,-RCSF,SEEK_CUR);
			pozv=LOC;
			gotoxy(16,8);printf("%30.30s",artf.den);
			gotoxy(16,10);printf("%22.22s",artf.localitate);
			gotoxy(16,12);printf("%13.13s",artf.cod_fiscal);
			gotoxy(16,14);printf("%u",artf.sw_intern);
			gotoxy(16,16);printf("%-3u",artf.cod_selectie);
			gotoxy(16,18);printf("%-9lu",artf.cont);
			nr++;
		}
		if(nr==1)
		{
			gotoxy(16,20);printf(" ");gotoxy(16,20);
			if(citire_text(1,man)) GRESIT
			strupr(man);
			if(man[0]!='D'&&man[0]!='N') GRESIT
			if(man[0]=='D')
			{
				pnf->cod=artf.cod=0;
				WRITE(nff,&artf,RCSF);
				CLOSE(nff);
				nff=Open(pathd,nume_nomf,O_BINARY|O_RDWR);
				pnf=qnf+nartf;
				mut_mare(fcnf,(uchar *)qnf,(uchar *)pnf,pozv+1,sizeof(*qnf));
				pnf=qnf+nartf-1;
				artf.cod=pnf->cod;
				if(!artf.cod) return;
			}
			nr=0;
		}
	}
}

void editare(void)
{
	if(!nartf) return;
	if(!nrpag) cernrpag();
	nr=nrpag;
	printf("\nDe la:");ix=wherex();iy=wherey();
	while(true)
	{
		gotoxy(ix,iy);printf("%5s","");gotoxy(ix,iy);
		i=citire_numar(5,0,0,man);
		if(i==ENTER) {dela=1;break;}
		if(i) GRESIT
		intreg=atol(man);
		if(!intreg||intreg>0xFFFE) GRESIT
		dela=intreg;
		break;
	}
	gotoxy(ix+6,iy);printf("Pana la:");ix=wherex();iy=wherey();
	while(true)
	{
		gotoxy(ix,iy);printf("%5s","");gotoxy(ix,iy);
		i=citire_numar(5,0,0,man);
		if(i==ENTER) {pnla=0xFFFF;break;}
		if(i) GRESIT
		intreg=atol(man);
		if(!intreg||intreg>0xFFFE) GRESIT
		pnla=intreg;
		if(pnla<dela) GRESIT
		break;
	}
	for(i=0;i<nartf;i++)
	{
		pnf=qnf+i;
		if(pnf->cod<dela) continue;
		if(pnf->cod>pnla) break;
		LSEEK(nff,pnf->pozitia*RCSF,SEEK_SET);
		READ(nff,&artf,RCSF);
		if(nr+1>nrpag)
		{
			if(fis!=stdout) fprintf(fis,"\n");
			if(apasa()) return;
			nr=4;
			sprintf(man,"Nomenclator                                                     FURNIZORI");SCR(man);
			sprintf(man,"=========================================================================");SCR(man);
			sprintf(man,"|  Cod|Denumire furnizor             |Cod fiscal   |EXTERN|Sel|Cont     |");SCR(man);
			sprintf(man,"=========================================================================");SCR(man);
		}
		sprintf(man,"|%5u|%30.30s|%13.13s|",artf.cod,artf.den,artf.cod_fiscal);
		if(artf.sw_intern==1) sprintf(man+strlen(man),"      |");
		if(artf.sw_intern==2) sprintf(man+strlen(man),"EXTERN|");
		if(artf.sw_intern==3) sprintf(man+strlen(man),"SUBUN.|");
		sprintf(man+strlen(man),"%3u|%-9lu|",artf.cod_selectie,artf.cont);
		SCR(man);
		nr++;
	}
	sprintf(man,"=========================================================================");
	SCR(man);
	if(fis==stdprn) fprintf(fis,"\n");
}

void ecran(uchar *mesaj)
{
	clrscr();
	gotoxy(1,3);printf("%s END = Terminare",mesaj);
	gotoxy(1, 6);printf("Cod............:");
	gotoxy(1, 8);printf("Denumire......:");
	gotoxy(1,10);printf("Localitate....:");
	gotoxy(1,12);printf("Cod fiscal....:");
	gotoxy(1,14);printf("Tip (1, 2, 3) :    1=din tara, 2=extern, 3=subunitate");
	gotoxy(1,16);printf("Selectie......:    0-255");
	gotoxy(1,18);printf("Cont..........:");
	if(mesaj[0]=='S')
	{
		gotoxy(1,20);printf("Stergeti (D,N):");
	}
}

void terminare(void)
{
	if(!SW) return;
	p=q=(struct TAB *)O;
	LSEEK(nff,0l,SEEK_SET);
	printf("\n%s citire:%lu/",nume_nomf,nartf);
	ix=wherex();iy=wherey();intreg=0;
	for(i=0;i<nartf;i++)
	{
		if(i%10==0) {gotoxy(ix,iy);printf("%u",i);}
		READ(nff,&artf,RCSF);
		if(!artf.cod) continue;
		strncpy((uchar *)p->den,artf.den,30);
		p->pozitia=i;
		p++;intreg++;
	}
	nartf=intreg;
	gotoxy(ix,iy);printf("%lu Sortare",nartf);
	sort(fc,(uchar *)q,nartf,sizeof(*q));
	printf("\n%s rescriere:%lu/",nume_nomf,nartf);
	ix=wherex();iy=wherey();
	for(i=0;i<nartf;i++)
	{
		if(i%10==0) {gotoxy(ix,iy);printf("%u",i);}
		p=q+i;
		LSEEK(nff,p->pozitia*RCSF,SEEK_SET);
		READ(nff,&artf,RCSF);
		LSEEK(nff,-RCSF,SEEK_CUR);
		artf.cod_sortare=i+1;
		WRITE(nff,&artf,RCSF);
	}
	gotoxy(ix,iy);printf("%lu",nartf);
	CLOSE(nff);
}

void recodificare(void)
{
	printf("\nCont vechi/END:");ix=wherex();iy=wherey();
	while(true)
	{
		gotoxy(ix,iy);printf("%9s","");gotoxy(ix,iy);
		i=citire_numar(9,0,0,man);
		if(i==END) return;
		if(i) GRESIT
		contv=atol(man);
		if(!contv) GRESIT
		break;
	}
	gotoxy(ix+10,iy);printf("Cont nou/END:");ix=wherex();iy=wherey();
	while(true)
	{
		gotoxy(ix,iy);printf("%9s","");gotoxy(ix,iy);
		i=citire_numar(9,0,0,man);
		if(i==END) return;
		if(i) GRESIT
		contn=atol(man);
		if(!contn) GRESIT
		if(contn==contv) GRESIT
		break;
	}
	LSEEK(nff,0l,SEEK_SET);
	intreg=0;
	for(i=0;i<nartf;i++)
	{
		READ(nff,&artf,RCSF);
		if(artf.cont!=contv) continue;
		artf.cont=contn;
		LSEEK(nff,-RCSF,SEEK_CUR);
		WRITE(nff,&artf,RCSF);
		intreg++;
	}
	if(intreg)
	{
		CLOSE(nff);
		nff=Open(pathd,nume_nomf,O_BINARY|O_RDWR);
		printf("\nS-au operat %lu schimbari.",intreg);
	}
	else printf("\nNu s-a operat nici o schimbare.");
}
