//06-mar-2007 20:19:39

typedef unsigned short ushort;
typedef unsigned long  ulong;
typedef unsigned char  uchar;

uchar dataa[]="01-ian-2007";
uchar  oraa[]="00:00:00";

#include "aplic.h"
#include "savalin.h"
#define DEF_CLIENTI
#define CORECTIE
#include "struct.h"

void adaugari(void);
void modificari(void);
void stergeri(void);
void editare(void);
void terminare(void);
void ecran(uchar *mesaj);
void recodificare(void);
void reafis(void);

ulong intreg;
ushort i,j,sec,dela,pnla;
uchar tip_act,SW,den[40];
ulong contv,contn;
short stare;
char sens;
uchar lin,col;

struct TAB
{
	uchar  den[40];
	ushort pozitia;
} *p,*q;

int fc(void)
{
	PUN(TAB)
	return strnicmp((uchar *)A->den,(uchar *)B->den,40);
}
uchar Ecran[25][80]=
{
	"--------------------------------------------------------------------------------",//00
	"|    A,M,S,E,T:                                                                |",//01
	"|------------------------------------------------------------------------------|",//02
	"|Cod client...:                                                                |",//03
	"|Denumire.....:                                                                |",//04
	"|Cod fiscal...:                      Nr.inreg.RC:                              |",//05
	"|Judetul......:                                                                |",//06
	"|Localitatea..:                                                                |",//07
	"|Strada.......:                                                                |",//08
	"|Numar........:              Bloc:         Scara:      Etaj:     Apartament:   |",//09
	"|Telefon fix..:                                                                |",//10
	"|Telefon mobil:                                                                |",//11
	"|Contul.......:                                                                |",//12
	"|Banca........:                                                                |",//13
	"|Nr.contract..:                                                                |",//14
	"|Cod agent....:                                                                |",//15
	"|Numar masina :                                                                |",//16
	"|Nume delegat :                         Serie CI:    Numar:                    |",//17
	"|Politia......:                                                                |",//18
	"|Tip client...:                                                                |",//19
	"|Cod selectie :                                                                |",//20
	"|Cont contabil:                                                                |",//21
	"|Scadenta.....:                                                                |",//22
	"|Adaos........:                                                                |",//23
	"--------------------------------------------------------------------------------" //24
};
uchar ecr[25][80][2];

int main(int _argc,uchar *_argv[])
{
	if(_argc-3)
	{
		printf("Intrati cu procedura.");abo();
	}
	sprintf(man,"%2.2s",_argv[_argc-1]+8);
	margine_stanga=atoi(man);
	sprintf(man,"%1.1s",_argv[_argc-1]+10);
	tip_prn=atoi(man);
	sprintf(pathd,"%s",_argv[_argc-1]+11);
	lg_pathd=strlen(pathd);
	prez("A C T N O M C","Actualizare NOMENCLATOR CLIENTI");
	corectie((uchar *)Ecran,25,80);
	strncpy(nume_nomc+4,_argv[_argc-1],4);
	strncpy(nume_nomc,_argv[_argc-1]+6,2);
	RCSC=sizeof(artc);
	if((nfc=Open(pathd,nume_nomc,O_BINARY|O_RDWR))<1)
	{
		printf("\nFisier %s absent. Se creeaza (D,N):",
		nume_nomc);ix=wherex();iy=wherey();
		while(true)
		{
			gotoxy(ix,iy);printf(" ");gotoxy(ix,iy);
			if(citire_text(1,man)) GRESIT
			strupr(man);
			if(man[0]=='N') exit(0);
			if(man[0]!='D') GRESIT
			break;
		}
		if((nfc=Open(pathd,nume_nomc,FA_ARCH))<1)
		{
			printf("\nFisierul %s nu poate fi creat.",
			nume_nomc);abo();
		}
	}
	if((nartc=filelength(nfc))%RCSC)
	{
		printf("\nFisier %s incoerent.",nume_nomc);
		abo();
	}
	stare=lock(nfc,0l,nartc);
	nartc/=RCSC;
	qnc=pnc=(struct TABC *)O;
	printf("\n%s citire:%lu/",nume_nomc,nartc);
	ix=wherex();iy=wherey();
	for(i=0;i<nartc;i++)
	{
		if(i%10==0) {gotoxy(ix,iy);printf("%u",i);}
		READ(nfc,&artc,RCSC);
		pnc->cod=artc.cod;
		pnc->pozitia=i;
		pnc++;
	}
	gotoxy(ix,iy);printf("%lu Sortare",nartc);
	sort(fcnc,(uchar *)qnc,nartc,sizeof(*qnc));
	SW=0;
	while(true)
	{
		printf("\nA=Adaugari    M=Modificari");
		printf("\nS=Stergeri    E=Editare");
		printf("\nR=Recod.cont  T=Terminare");
		printf("\nFunctie (A,M,S,E,R,T):");
		ix=wherex();iy=wherey();
		while(true)
		{
			gotoxy(ix,iy);printf(" ");gotoxy(ix,iy);
			if(citire_text(1,man)) GRESIT
			strupr(man);
			tip_act=man[0];
			if(tip_act=='A') {adaugari();clrscr();break;}
			if(tip_act=='M') {modificari();clrscr();break;}
			if(tip_act=='S') {stergeri();clrscr();break;}
			if(tip_act=='E') {editare();break;}
			if(tip_act=='R') {recodificare();break;}
			if(tip_act=='T') {terminare();exit(0);}
			GRESIT
		}
	}
	return 0;
}

void adaugari(void)
{
	memset(&artc,' ',(int)RCSC);
	artc.cod=0;
	if(nartc)
	{
		pnc=qnc+nartc-1;
		artc.cod=pnc->cod;
	}
	artc.cont=4111;
	artc.sw_intern=1;
	artc.adaos=0;
	artc.scadenta=0;
	artc.sold=0;
	artc.selectie=0;
	artc.cod_agent=0;
	artc.cod++;
	nr=0;
	while(true)
	{
		reafis();
		if(nr==0)
		{
			gotoxy(16,4);i=citire_numar(5,0,0,man);
			if(i==END||i==SAGU) return;
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artc.cod);
				i=0;
			}
			if(i) GRESIT
			intreg=atol(man);
			if(!intreg||intreg>0xFFFE) GRESIT
			i=intreg;
			caut_cln(i);
			if(GASIT)
			{
				eroare("Client existent");
				continue;
			}
			artc.cod=i;
			nr++;
			continue;
		}
		if(nr==1)
		{
			gotoxy(16,5);i=cit_text(40,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%40.40s",artc.den);i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ') GRESIT
			strncpy(artc.den,man,40);
			nr++;
			continue;
		}
		if(nr==2)
		{
			gotoxy(16,6);i=cit_text(13,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%13.13s",artc.cod_fiscal);
				i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ')
			{
				for(i=1;i<13;i++) if(man[i]!=' ') break;
				if(i<13) GRESIT
			}
			else
			{
				for(i=0;i<13;i++) if(man[i]==' ') break;
				if(i<4) GRESIT
			}
			strncpy(artc.cod_fiscal,man,13);
			nr++;continue;
		}
		if(nr==3)
		{
			gotoxy(50,6);i=cit_text(15,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%15.15s",artc.nr_reg);
				i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ')
			{
				for(i=1;i<15;i++) if(man[i]!=' ') break;
				if(i<15) GRESIT
			}
			strncpy(artc.nr_reg,man,15);
			nr++;continue;
		}
		if(nr==4)
		{
			gotoxy(16,7);i=cit_text(16,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%16.16s",artc.judet);i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ')
			{
				for(i=1;i<16;i++) if(man[i]!=' ') break;
				if(i<16) GRESIT
			}
			strncpy(artc.judet,man,16);
			nr++;continue;
		}
		if(nr==5)
		{
			gotoxy(16,8);
			i=cit_text(30,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%30.30s",artc.localitate);i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ') GRESIT
			strncpy(artc.localitate,man,30);
			nr++;continue;
		}
		if(nr==6)
		{
			gotoxy(16,9);
			i=cit_text(30,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%30.30s",artc.strada);i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ')
			{
				for(j=0;j<30;j++) if(man[j]!=' ') break;
				if(j<30) GRESIT
			}
			strncpy(artc.strada,man,30);
			nr++;continue;
		}
		if(nr==7)
		{
			gotoxy(16,10);
			i=cit_text(5,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%5.5s",artc.numar);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<5;j++) if(man[j]!=' ') break;
				if(j<5) GRESIT
			}
			strncpy(artc.numar,man,5);
			nr++;continue;
		}
		if(nr==8)
		{
			gotoxy(35,10);
			i=cit_text(8,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%8.8s",artc.bloc);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<8;j++) if(man[j]!=' ') break;
				if(j<8) GRESIT
			}
			strncpy(artc.bloc,man,8);
			nr++;continue;
		}
		if(nr==9)
		{
			gotoxy(50,10);
			i=cit_text(5,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%5.5s",artc.scara);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<5;j++) if(man[j]!=' ') break;
				if(j<5) GRESIT
			}
			strncpy(artc.scara,man,5);
			nr++;continue;
		}
		if(nr==10)
		{
			gotoxy(61,10);
			i=cit_text(3,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%3.3s",artc.etaj);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<3;j++) if(man[j]!=' ') break;
				if(j<3) GRESIT
			}
			strncpy(artc.etaj,man,3);
			nr++;continue;
		}
		if(nr==11)
		{
			gotoxy(77,10);
			i=cit_text(3,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%3.3s",artc.apt);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<3;j++) if(man[j]!=' ') break;
				if(j<3) GRESIT
			}
			strncpy(artc.apt,man,3);
			nr++;continue;
		}
		if(nr==12)
		{
			gotoxy(16,11);
			i=cit_text(20,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%20.20s",artc.telefon_fix);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<20;j++) if(man[j]!=' ') break;
				if(j<20) GRESIT
			}
			strncpy(artc.telefon_fix,man,20);
			nr++;continue;
		}
		if(nr==13)
		{
			gotoxy(16,12);
			i=cit_text(20,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%20.20s",artc.telefon_mobil);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<20;j++) if(man[j]!=' ') break;
				if(j<20) GRESIT
			}
			strncpy(artc.telefon_mobil,man,20);
			nr++;continue;
		}
		if(nr==14)
		{
			gotoxy(16,13);
			i=cit_text(24,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%24.24s",artc.cont_bancar);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<24;j++) if(man[j]!=' ') break;
				if(j<24) GRESIT
			}
			strncpy(artc.cont_bancar,man,24);
			nr++;continue;
		}
		if(nr==15)
		{
			gotoxy(16,14);
			i=cit_text(24,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%24.24s",artc.banca);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<24;j++) if(man[j]!=' ') break;
				if(j<24) GRESIT
			}
			strncpy(artc.banca,man,24);
			nr++;continue;
		}
		if(nr==16)
		{
			gotoxy(16,15);
			i=cit_text(16,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%16.16s",artc.contract);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<16;j++) if(man[j]!=' ') break;
				if(j<16) GRESIT
			}
			strncpy(artc.contract,man,16);
			nr++;continue;
		}
		if(nr==17)
		{
			gotoxy(16,16);i=citire_numar(3,0,0,man);
			if(i==SAGU) {nr--;sens=-1;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%u",artc.cod_agent);i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i>0xFF) GRESIT
			artc.cod_agent=i;
			nr++;continue;
		}
		if(nr==18)
		{
			gotoxy(16,17);i=cit_text(16,man);
			if(i==SAGU) {nr--;sens=-1;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%16.16s",artc.masina);i=0;
			}
			if(i) GRESIT
			strupr(man);
			if(man[0]==' ')
			{
				for(j=0;j<16;j++) if(man[j]!=' ') break;
				if(j<16) GRESIT
			}
			strncpy(artc.masina,man,16);
			nr++;continue;
		}
		if(nr==19)
		{
			gotoxy(16,18);i=cit_text(24,man);
			if(i==SAGU) {nr--;sens=-1;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%24.24s",artc.delegat);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<24;j++) if(man[j]!=' ') break;
				if(j<24) GRESIT
			}
			man[24]='\0';
			strlwr(man);
			man[0]=toupper(man[0]);
			for(j=1;j<24;j++) if(!isalpha(man[j-1])) man[j]=toupper(man[j]);
			strncpy(artc.delegat,man,24);
			nr++;continue;
		}
		if(nr==20)
		{
			gotoxy(50,18);i=cit_text(2,man);
			if(i==SAGU) {nr--;sens=-1;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%2.2s",artc.serie_buletin);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<2;j++) if(man[j]!=' ') break;
				if(j<2) GRESIT
			}
			strncpy(artc.serie_buletin,man,2);
			nr++;continue;
		}
		if(nr==21)
		{
			gotoxy(60,18);i=cit_text(8,man);
			if(i==SAGU) {nr--;sens=-1;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%8.8s",artc.nr_buletin);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<8;j++) if(man[j]!=' ') break;
				if(j<8) GRESIT
			}
			strncpy(artc.nr_buletin,man,8);
			nr++;continue;
		}
		if(nr==22)
		{
			gotoxy(16,19);i=cit_text(24,man);
			if(i==SAGU) {nr--;sens=-1;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%24.24",artc.politie);i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ')
			{
				for(j=0;j<24;j++) if(man[j]!=' ') break;
				if(j<24) GRESIT
			}
			strncpy(artc.politie,man,24);
			nr++;continue;
		}
		if(nr==23)
		{
			gotoxy(16,20);i=citire_numar(1,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artc.sw_intern);
				i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i<1||i>3) GRESIT
			artc.sw_intern=i;
			nr++;continue;
		}
		if(nr==24)
		{
			gotoxy(16,21);i=citire_numar(3,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artc.selectie);
				i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i>=0xFF) GRESIT
			artc.selectie=i;
			nr++;continue;
		}
		if(nr==25)
		{
			gotoxy(16,22);i=citire_numar(9,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%lu",artc.cont);
				i=0;
			}
			if(i) GRESIT
			intreg=atol(man);
			if(!intreg) GRESIT
			artc.cont=intreg;
			nr++;continue;
		}
		if(nr==26)
		{
			gotoxy(16,23);
			i=citire_numar(3,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artc.scadenta);
				i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i>0xFF) GRESIT
			artc.scadenta=i;
			nr++;continue;
		}
		if(nr==27)
		{
			gotoxy(16,24);
			i=citire_numar(3,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artc.adaos);
				i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i>0xFF) GRESIT
			artc.adaos=i;
			nr++;continue;
		}
		if(nr==28)
		{
			SW=1;
			if(nartc&&!qnc->cod)
			{
				qnc->cod=artc.cod;
				sec=qnc->pozitia;
				pnc=qnc+nartc;
				mut_mic(fcnc,(uchar *)qnc,(uchar *)pnc,nartc,sizeof(*qnc));
			}
			else
			{
				sec=nartc;
				pnc=qnc+nartc;
				pnc->cod=artc.cod;
				pnc->pozitia=sec;
				pnc++;nartc++;
				mut_mare(fcnc,(uchar *)qnc,(uchar *)pnc,nartc,sizeof(*qnc));
			}
			LSEEK(nfc,sec*RCSC,SEEK_SET);
			artc.cod_sortare=0;
			WRITE(nfc,&artc,RCSC);
			CLOSE(nfc);
			nfc=Open(pathd,nume_nomc,O_BINARY|O_RDWR);
			artc.cod++;
			nr=0;
		}
	}
}

void modificari(void)
{
	if(!nartc) return;
	pnc=qnc+nartc-1;
	if(!pnc->cod) return;
	LSEEK(nfc,pnc->pozitia*RCSC,SEEK_SET);
	READ(nfc,&artc,RCSC);
	nr=0;
	while(true)
	{
		reafis();
		if(nr==0)
		{
			gotoxy(16,4);i=citire_numar(5,0,0,man);
			if(i==END||i==SAGU) return;
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artc.cod);
				i=0;
			}
			if(i) GRESIT
			intreg=atol(man);
			if(!intreg||intreg>0xFFFE) GRESIT
			i=intreg;
			caut_cln(i);
			if(NEGASIT)
			{
				eroare("Client inexistent");
				continue;
			}
			LSEEK(nfc,pnc->pozitia*RCSC,SEEK_SET);
			READ(nfc,&artc,RCSC);
			LSEEK(nfc,-RCSC,SEEK_CUR);
			strncpy(den,artc.den,40);
			nr++;continue;
		}
		if(nr==1)
		{
			gotoxy(16,5);i=cit_text(40,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%40.40s",artc.den);i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ') GRESIT
			strncpy(artc.den,man,40);
			nr++;
			continue;
		}
		if(nr==2)
		{
			gotoxy(16,6);i=cit_text(13,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%13.13s",artc.cod_fiscal);
				i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ')
			{
				for(i=1;i<13;i++) if(man[i]!=' ') break;
				if(i<13) GRESIT
			}
			else
			{
				for(i=0;i<13;i++) if(man[i]==' ') break;
				if(i<4) GRESIT
			}
			strncpy(artc.cod_fiscal,man,13);
			nr++;continue;
		}
		if(nr==3)
		{
			gotoxy(50,6);i=cit_text(15,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%15.15s",artc.nr_reg);
				i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ')
			{
				for(i=1;i<15;i++) if(man[i]!=' ') break;
				if(i<15) GRESIT
			}
			strncpy(artc.nr_reg,man,15);
			nr++;continue;
		}
		if(nr==4)
		{
			gotoxy(16,7);i=cit_text(16,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%16.16s",artc.judet);i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ')
			{
				for(i=1;i<16;i++) if(man[i]!=' ') break;
				if(i<16) GRESIT
			}
			strncpy(artc.judet,man,16);
			nr++;continue;
		}
		if(nr==5)
		{
			gotoxy(16,8);
			i=cit_text(30,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%30.30s",artc.localitate);i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ') GRESIT
			strncpy(artc.localitate,man,30);
			nr++;continue;
		}
		if(nr==6)
		{
			gotoxy(16,9);
			i=cit_text(30,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%30.30s",artc.strada);i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ')
			{
				for(j=0;j<30;j++) if(man[j]!=' ') break;
				if(j<30) GRESIT
			}
			strncpy(artc.strada,man,30);
			nr++;continue;
		}
		if(nr==7)
		{
			gotoxy(16,10);
			i=cit_text(5,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%5.5s",artc.numar);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<5;j++) if(man[j]!=' ') break;
				if(j<5) GRESIT
			}
			strncpy(artc.numar,man,5);
			nr++;continue;
		}
		if(nr==8)
		{
			gotoxy(35,10);
			i=cit_text(8,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%8.8s",artc.bloc);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<8;j++) if(man[j]!=' ') break;
				if(j<8) GRESIT
			}
			strncpy(artc.bloc,man,8);
			nr++;continue;
		}
		if(nr==9)
		{
			gotoxy(50,10);
			i=cit_text(5,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%5.5s",artc.scara);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<5;j++) if(man[j]!=' ') break;
				if(j<5) GRESIT
			}
			strncpy(artc.scara,man,5);
			nr++;continue;
		}
		if(nr==10)
		{
			gotoxy(61,10);
			i=cit_text(3,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%3.3s",artc.etaj);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<3;j++) if(man[j]!=' ') break;
				if(j<3) GRESIT
			}
			strncpy(artc.etaj,man,3);
			nr++;continue;
		}
		if(nr==11)
		{
			gotoxy(77,10);
			i=cit_text(3,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%3.3s",artc.apt);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<3;j++) if(man[j]!=' ') break;
				if(j<3) GRESIT
			}
			strncpy(artc.apt,man,3);
			nr++;continue;
		}
		if(nr==12)
		{
			gotoxy(16,11);
			i=cit_text(20,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%20.20s",artc.telefon_fix);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<20;j++) if(man[j]!=' ') break;
				if(j<20) GRESIT
			}
			strncpy(artc.telefon_fix,man,20);
			nr++;continue;
		}
		if(nr==13)
		{
			gotoxy(16,12);
			i=cit_text(20,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%20.20s",artc.telefon_mobil);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<20;j++) if(man[j]!=' ') break;
				if(j<20) GRESIT
			}
			strncpy(artc.telefon_mobil,man,20);
			nr++;continue;
		}
		if(nr==14)
		{
			gotoxy(16,13);
			i=cit_text(24,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%24.24s",artc.cont_bancar);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<24;j++) if(man[j]!=' ') break;
				if(j<24) GRESIT
			}
			strncpy(artc.cont_bancar,man,24);
			nr++;continue;
		}
		if(nr==15)
		{
			gotoxy(16,14);
			i=cit_text(24,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%24.24s",artc.banca);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<24;j++) if(man[j]!=' ') break;
				if(j<24) GRESIT
			}
			strncpy(artc.banca,man,24);
			nr++;continue;
		}
		if(nr==16)
		{
			gotoxy(16,15);
			i=cit_text(16,man);
			if(i==SAGU) {nr--;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%16.16s",artc.contract);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<16;j++) if(man[j]!=' ') break;
				if(j<16) GRESIT
			}
			strncpy(artc.contract,man,16);
			nr++;continue;
		}
		if(nr==17)
		{
			gotoxy(16,16);i=citire_numar(3,0,0,man);
			if(i==SAGU) {nr--;sens=-1;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%u",artc.cod_agent);i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i>0xFF) GRESIT
			artc.cod_agent=i;
			nr++;continue;
		}
		if(nr==18)
		{
			gotoxy(16,17);i=cit_text(16,man);
			if(i==SAGU) {nr--;sens=-1;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%16.16s",artc.masina);i=0;
			}
			if(i) GRESIT
			strupr(man);
			if(man[0]==' ')
			{
				for(j=0;j<16;j++) if(man[j]!=' ') break;
				if(j<16) GRESIT
			}
			strncpy(artc.masina,man,16);
			nr++;continue;
		}
		if(nr==19)
		{
			gotoxy(16,18);i=cit_text(24,man);
			if(i==SAGU) {nr--;sens=-1;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%24.24s",artc.delegat);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<24;j++) if(man[j]!=' ') break;
				if(j<24) GRESIT
			}
			man[24]='\0';
			strlwr(man);
			man[0]=toupper(man[0]);
			for(j=1;j<24;j++) if(!isalpha(man[j-1])) man[j]=toupper(man[j]);
			strncpy(artc.delegat,man,24);
			nr++;continue;
		}
		if(nr==20)
		{
			gotoxy(50,18);i=cit_text(2,man);
			if(i==SAGU) {nr--;sens=-1;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%2.2s",artc.serie_buletin);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<2;j++) if(man[j]!=' ') break;
				if(j<2) GRESIT
			}
			strncpy(artc.serie_buletin,man,2);
			nr++;continue;
		}
		if(nr==21)
		{
			gotoxy(60,18);i=cit_text(8,man);
			if(i==SAGU) {nr--;sens=-1;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%8.8s",artc.nr_buletin);i=0;
			}
			if(i) GRESIT
			if(man[0]==' ')
			{
				for(j=0;j<8;j++) if(man[j]!=' ') break;
				if(j<8) GRESIT
			}
			strncpy(artc.nr_buletin,man,8);
			nr++;continue;
		}
		if(nr==22)
		{
			gotoxy(16,19);i=cit_text(24,man);
			if(i==SAGU) {nr--;sens=-1;continue;}
			if(i==SAGD||i==ENTER)
			{
				sprintf(man,"%24.24",artc.politie);i=0;
			}
			if(i) GRESIT
			man[0]=toupper(man[0]);
			if(man[0]==' ')
			{
				for(j=0;j<24;j++) if(man[j]!=' ') break;
				if(j<24) GRESIT
			}
			strncpy(artc.politie,man,24);
			nr++;continue;
		}
		if(nr==23)
		{
			gotoxy(16,20);i=citire_numar(1,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artc.sw_intern);
				i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i<1||i>3) GRESIT
			artc.sw_intern=i;
			nr++;continue;
		}
		if(nr==24)
		{
			gotoxy(16,21);i=citire_numar(3,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artc.selectie);
				i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i>=0xFF) GRESIT
			artc.selectie=i;
			nr++;continue;
		}
		if(nr==25)
		{
			gotoxy(16,22);i=citire_numar(9,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%lu",artc.cont);
				i=0;
			}
			if(i) GRESIT
			intreg=atol(man);
			if(!intreg) GRESIT
			artc.cont=intreg;
			nr++;continue;
		}
		if(nr==26)
		{
			gotoxy(16,23);
			i=citire_numar(3,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artc.scadenta);
				i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i>0xFF) GRESIT
			artc.scadenta=i;
			nr++;continue;
		}
		if(nr==27)
		{
			gotoxy(16,24);
			i=citire_numar(3,0,0,man);
			if(i==SAGU) {nr--;continue;}
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artc.adaos);
				i=0;
			}
			if(i) GRESIT
			i=atoi(man);
			if(i>0xFF) GRESIT
			artc.adaos=i;
			nr++;continue;
		}
		if(nr==28)
		{
			if(strnicmp(den,artc.den,40))
			{
				SW=1;
				artc.cod_sortare=0;
			}
			WRITE(nfc,&artc,RCSC);
			CLOSE(nfc);
			nfc=Open(pathd,nume_nomc,O_BINARY|O_RDWR);
			nr=0;
		}
	}
}

void stergeri(void)
{
	if(!nartc) return;
	pnc=qnc+nartc-1;
	if(!pnc->cod) return;
	LSEEK(nfc,pnc->pozitia*RCSC,SEEK_SET);
	READ(nfc,&artc,RCSC);
	nr=0;
	while(true)
	{
		reafis();
		if(nr==0)
		{
			gotoxy(16,4);i=citire_numar(5,0,0,man);
			if(i==END||i==SAGU) return;
			if(i==ENTER||i==SAGD)
			{
				sprintf(man,"%u",artc.cod);
				i=0;
			}
			if(i) GRESIT
			intreg=atol(man);
			if(!intreg||intreg>0xFFFE) GRESIT
			i=intreg;
			caut_cln(i);
			if(NEGASIT)
			{
				eroare("Client inexistent");
				continue;
			}
			LSEEK(nfc,pnc->pozitia*RCSC,SEEK_SET);
			READ(nfc,&artc,RCSC);
			LSEEK(nfc,-RCSC,SEEK_CUR);
			pozv=LOC;
			nr++;continue;
		}
		if(nr==1)
		{
			gotoxy(50,4);
			if(citire_text(1,man)) GRESIT
			strupr(man);
			if(man[0]!='D'&&man[0]!='N') GRESIT
			nr=0;
			if(man[0]=='N') continue;
			pnc->cod=artc.cod=0;
			WRITE(nfc,&artc,RCSC);
			CLOSE(nfc);
			nfc=Open(pathd,nume_nomc,O_BINARY|O_RDWR);
			pnc=qnc+nartc;
			mut_mare(fcnc,(uchar *)qnc,(uchar *)pnc,pozv+1,sizeof(*qnc));
			pnc=qnc+nartc-1;
			artc.cod=pnc->cod;
			if(!artc.cod) return;
		}
	}
}

void editare(void)
{
	if(!nartc) return;
	if(!nrpag) cernrpag();
	nr=nrpag;
	printf("\nDe la/ENTER:");ix=wherex();iy=wherey();
	while(true)
	{
		gotoxy(ix,iy);printf("%5s","");gotoxy(ix,iy);
		i=citire_numar(5,0,0,man);
		if(i==ENTER) {dela=1;break;}
		if(i) GRESIT
		intreg=atol(man);
		if(!intreg||intreg>0xFFFE) GRESIT
		dela=intreg;
		break;
	}
	gotoxy(ix+6,iy);printf("Pana la/ENTER:");ix=wherex();iy=wherey();
	while(true)
	{
		gotoxy(ix,iy);printf("%5s","");gotoxy(ix,iy);
		i=citire_numar(5,0,0,man);
		if(i==ENTER) {pnla=0xFFFF;break;}
		if(i) GRESIT
		intreg=atol(man);
		if(!intreg||intreg>0xFFFE) GRESIT
		pnla=intreg;
		if(pnla<dela) GRESIT
		break;
	}
	for(i=0;i<nartc;i++)
	{
		pnc=qnc+i;
		if(pnc->cod<dela) continue;
		if(pnc->cod>pnla) break;
		LSEEK(nfc,pnc->pozitia*RCSC,SEEK_SET);
		READ(nfc,&artc,RCSC);
		if(nr+1>nrpag)
		{
			if(fis!=stdout) fprintf(fis,"\n");
			if(apasa()) return;
			nr=4;
			sprintf(man,"Nomenclator                                                       CLIENTI");SCR(man);
			sprintf(man,"=========================================================================");SCR(man);
			sprintf(man,"|  Cod|Denumire client               |Cod fiscal   |Sel|Tip   |Cont     |");SCR(man);
			sprintf(man,"=========================================================================");SCR(man);
		}
		sprintf(man,"|%5u|%30.30s|%13.13s|%3u|",artc.cod,artc.den,artc.cod_fiscal,artc.selectie);
		if(artc.sw_intern==1) sprintf(man+strlen(man),"      |");
		if(artc.sw_intern==2) sprintf(man+strlen(man),"EXPORT|");
		if(artc.sw_intern==3) sprintf(man+strlen(man),"SUBUN.|");
		sprintf(man+strlen(man),"%-9lu|",artc.cont);
		SCR(man);
		nr++;
	}
	sprintf(man,"=========================================================================");SCR(man);
	if(fis==stdprn) fprintf(fis,"\n");
}

void ecran(uchar *mesaj)
{
	clrscr();
	gotoxy(1, 1);printf("%s END = Terminare",mesaj);
	gotoxy(1, 3);printf("Cod...............:");
	gotoxy(1, 4);printf("Denumire..........:");
	gotoxy(1, 5);printf("Localitate........:");
	gotoxy(1, 6);printf("Judet.............:");
	gotoxy(1, 7);printf("Cod fiscal sau CNP:");
	gotoxy(1, 8);printf("Banca.............:");
	gotoxy(1, 9);printf("Contul............:");
	gotoxy(1,10);printf("Nr.autorizatie 1  :          Din data:");
	gotoxy(1,11);printf("Nr.autorizatie 2  :          Din data:");
	gotoxy(1,12);printf("Nr.autorizatie 3  :          Din data:");
	gotoxy(1,13);printf("Nr.autorizatie 4  :          Din data:");
	gotoxy(1,14);printf("Nr.autorizatie 5  :          Din data:");
	gotoxy(1,15);printf("Nr.autorizatie 6  :          Din data:");
	gotoxy(1,16);printf("Nr.autorizatie 7  :          Din data:");
	gotoxy(1,17);printf("Nr.autorizatie 8  :          Din data:");
	gotoxy(1,18);printf("Numar contract....:          Din data:");
	gotoxy(1,19);printf("Cod agent.........:");
	gotoxy(1,20);printf("Tip (1,2,3).......:   1=din tara, 2=export, 3=subunitate");
	gotoxy(1,21);printf("Cod selectie......:");
	gotoxy(1,22);printf("Cont contabil.....:");
	gotoxy(1,23);printf("Scadenta in zile..:");
	if(mesaj[0]=='S')
	{
		gotoxy(1,24);printf("Stergeti (D,N)....:");
	}
}

void terminare(void)
{
	if(!SW) return;
	p=q=(struct TAB *)O;
	LSEEK(nfc,0l,SEEK_SET);
	printf("\n%s citire:%lu/",nume_nomc,nartc);
	ix=wherex();iy=wherey();intreg=0;
	for(i=0;i<nartc;i++)
	{
		if(i%10==0) {gotoxy(ix,iy);printf("%u",i);}
		READ(nfc,&artc,RCSC);
		if(!artc.cod) continue;
		strncpy((uchar *)p->den,artc.den,40);
		p->pozitia=i;
		p++;intreg++;
	}
	nartc=intreg;
	gotoxy(ix,iy);printf("%lu Sortare",nartc);
	sort(fc,(uchar *)q,nartc,sizeof(*q));
	printf("\n%s rescriere:%lu/",nume_nomc,nartc);
	ix=wherex();iy=wherey();
	for(i=0;i<nartc;i++)
	{
		if(i%10==0) {gotoxy(ix,iy);printf("%u",i);}
		p=q+i;
		LSEEK(nfc,p->pozitia*RCSC,SEEK_SET);
		READ(nfc,&artc,RCSC);
		LSEEK(nfc,-RCSC,SEEK_CUR);
		artc.cod_sortare=i+1;
		WRITE(nfc,&artc,RCSC);
	}
	gotoxy(ix,iy);printf("%lu",nartc);
	CLOSE(nfc);
}

void recodificare(void)
{
	printf("\nCont vechi/END:");ix=wherex();iy=wherey();
	while(true)
	{
		gotoxy(ix,iy);printf("%9s","");gotoxy(ix,iy);
		i=citire_numar(9,0,0,man);
		if(i==END) return;
		if(i) GRESIT
		contv=atol(man);
		if(!contv) GRESIT
		break;
	}
	gotoxy(ix+10,iy);printf("Cont nou/END:");ix=wherex();iy=wherey();
	while(true)
	{
		gotoxy(ix,iy);printf("%9s","");gotoxy(ix,iy);
		i=citire_numar(9,0,0,man);
		if(i==END) return;
		if(i) GRESIT
		contn=atol(man);
		if(!contn) GRESIT
		if(contn==contv) GRESIT
		break;
	}
	CLOSE(nfc);
	nfc=Open(pathd,nume_nomc,O_BINARY|O_RDWR);
	intreg=0;
	for(i=0;i<nartc;i++)
	{
		READ(nfc,&artc,RCSC);
		if(artc.cont!=contv) continue;
		artc.cont=contn;
		LSEEK(nfc,-RCSC,SEEK_CUR);
		WRITE(nfc,&artc,RCSC);
		intreg++;
	}
	if(intreg)
	{
		CLOSE(nfc);
		nfc=Open(pathd,nume_nomc,O_BINARY|O_RDWR);
		printf("\nS-au operat %lu schimbari.",intreg);
	}
	else printf("\nNu s-a operat nici o schimbare.");
}

void reafis(void)
{
	Ecran[1][15]=tip_act;
	sprintf(man,"%-5u",artc.cod);
	strncpy(Ecran[3]+15,man,5);
	strncpy(Ecran[4]+15,artc.den,40);
	strncpy(Ecran[5]+15,artc.cod_fiscal,13);
	strncpy(Ecran[5]+49,artc.nr_reg,15);
	strncpy(Ecran[6]+15,artc.judet,16);
	strncpy(Ecran[7]+15,artc.localitate,30);
	strncpy(Ecran[8]+15,artc.strada,30);
	strncpy(Ecran[9]+15,artc.numar,5);
	strncpy(Ecran[9]+34,artc.bloc,8);
	strncpy(Ecran[9]+49,artc.scara,5);
	strncpy(Ecran[9]+60,artc.etaj,3);
	strncpy(Ecran[9]+76,artc.apt,3);
	strncpy(Ecran[10]+15,artc.telefon_fix,20);
	strncpy(Ecran[11]+15,artc.telefon_mobil,20);
	strncpy(Ecran[12]+15,artc.cont_bancar,24);
	strncpy(Ecran[13]+15,artc.banca,24);
	strncpy(Ecran[14]+15,artc.contract,16);
	if(artc.cod_agent) sprintf(man,"%-3u",artc.cod_agent);else sprintf(man,"%3s","");
	strncpy(Ecran[15]+15,man,3);
	strncpy(Ecran[16]+15,artc.masina,16);
	strncpy(Ecran[17]+15,artc.delegat,24);
	strncpy(Ecran[17]+49,artc.serie_buletin,2);
	strncpy(Ecran[17]+59,artc.nr_buletin,8);
	strncpy(Ecran[18]+15,artc.politie,24);
	sprintf(man,"%u",artc.sw_intern);
	strncpy(Ecran[19]+15,man,1);
	sprintf(man,"%-3u",artc.selectie);
	strncpy(Ecran[20]+15,man,3);
	sprintf(man,"%-9lu",artc.cont);
	strncpy(Ecran[21]+15,man,9);
	sprintf(man,"%-3u zile",artc.scadenta);
	strncpy(Ecran[22]+15,man,8);
	sprintf(man,"%-3u %%",artc.adaos);
	strncpy(Ecran[23]+15,man,5);
	if(tip_act=='S') sprintf(man,"Stergeti (D,N): ");else sprintf(man,"                ");
	strncpy(Ecran[3]+34,man,16);
	for(i=0;i<25;i++)
	{
		for(j=0;j<80;j++)
		{
			ecr[i][j][0]=Ecran[i][j];
			ecr[i][j][1]=0x3F;
		}
	}
	puttext(1,1,80,25,ecr);
}
