uchar pathd[60],lg_pathd;
uchar pathp[60],lg_pathp;

#define NRPOZ 50

#define MODUL "STOC"

uchar nume_ant[]="ANTEuuuu.FFF";
ulong RCSANT,nartant;
short nfant;
struct ANTET
{
	uchar  den_unit[32];
	uchar  TVA[3];
	uchar  culori[3];
} antet;

#ifdef DEFN
uchar nume_nom[]="aaNPuuuu.FFF";
short nfn;
ulong RCSN,nartn;
struct NOM
{
	ulong  cod;
	uchar  den[40];
	uchar  um[3];
	uchar marcaj;
	uchar tip;  //0=normal, 1=discount, 2=servicii
	double pret;
	double stoc_min;
	double stoc_max;
	ulong  cod_sortare;
} artn;
struct TABN
{
	ulong cod;
	ulong pozitia;
} *pn,*qn;
int fcn(void)
{
	PUN(TABN)
	TESTR(cod)
	return 0;
}
void caut_nom(ulong cod)
{
	stanga=-1;dreapta=nartn;
	while(stanga<dreapta-1)
	{
		mijloc=(stanga+dreapta)>>1;
		pn=qn+mijloc;
		TEST(cod,pn->cod)
		NEGASIT=0;LOC=mijloc;
		return;
	}
	NEGASIT=1;LOC=dreapta;
}
#endif

#ifdef DEF_GESTIUNI
uchar nume_nomg[]="aaGSuuuu.FFF";
short nfg;
ulong RCSG,nartg;
struct NOMG
{
	ushort cod;
	uchar  den[25];
	ulong  cont;
} artg;
struct TABG
{
	ushort cod;
	ushort pozitia;
} *pg,*qg;
int fcg(void)
{
	PUN(TABG)
	TESTR(cod)
	return 0;
}
void caut_gest(ushort cod)
{
	stanga=-1;dreapta=nartg;
	while(dreapta-stanga>1)
	{
		mijloc=(dreapta+stanga)>>1;
		pg=qg+mijloc;
		TEST(cod,pg->cod)
		NEGASIT=0;LOC=mijloc;return;
	}
	NEGASIT=1;LOC=dreapta;
}
#endif

#ifdef DEFS
uchar nume_stc[]="aaSTuuuu.Fll";
short nfs;
ulong RCSS,narts;
struct STOC
{
	ushort gest;
	ulong  cod;
	double pret;
	double cant;
	uchar  alz_ui[3];
	uchar  alz_ue[3];
} arts;
struct TABS
{
	ushort gest;
	ulong  cod;
	double pret;
	ushort pozitia;
} *ps,*qs;
int fcs(void)
{
	PUN(TABS)
	TESTR(gest)
	TESTR(cod)
	TESTR(pret)
	return 0;
}
void caut_stoc(ushort gest,ulong cod,double pret)
{
	stanga=-1;dreapta=narts;
	while(stanga<dreapta-1)
	{
		mijloc=(stanga+dreapta)>>1;
		ps=qs+mijloc;
		TEST(gest,ps->gest)
		TEST(cod,ps->cod)
		TEST(pret,ps->pret)
		NEGASIT=0;LOC=mijloc;
		return;
	}
	NEGASIT=1;LOC=dreapta;
}
#endif

#ifdef DEF_INTRARI
uchar nume_intr[]="aaINuuuu.Fll";
short nfin;
ulong RCSIN,nartin;
struct INTRARI
{
	ushort gest;
	uchar  tip_doc;
	// INTRARI
	//     1=NIR
	//     2=NOTA de PREDARE
	//     3=ALTE INTRARI
	uchar ziua;
	ulong  nr_doc;
	ulong  nr_fact;
	ushort cod_frn;
	struct
	{
		ulong  cod;
		double pret;          //fara TVA
		double cant;
		uchar  proc_TVA;
	} a[NRPOZ];
} artin;
#endif

#ifdef DEF_IESIRI
uchar nume_ies[]="aaESuuuu.Fll";
short nfes;
ulong RCSES,nartes;
struct IESIRI
{
	ushort gest;
	uchar  tip_doc;
	// IESIRI
	//     1=BON de CONSUM
	//     2=FISA LIMITA
	//     3=NOTA de TRANSFER
	//     4=VANZARE cu FACTURA
	//     5=ALTE IESIRI
	uchar ziua;
	ulong  nr_doc;
	ushort cod_cln;     //sau gestiunea primitoare la transfer
	ulong  comanda;     //sau factura la vanzare
	ulong  subcomanda;  //0xFFFFFFFF pentru cele provenite din generare RAPOARTE
	struct
	{
		ulong  cod;
		double pret;          //fara TVA
		double cant;
		double pret_vanzare;  //fara TVA
		uchar  proc_TVA;
	} a[NRPOZ];
} artes;
#endif

#ifdef DEF_COMENZI
uchar nume_nomcd[]="aaCDuuuu.FFF";
short nfcd;
ulong RCSCD,nartcd;
struct NOM_COM
{
	ulong  cod;
	uchar  den[49];
	uchar  tip_comanda;  //1=normala, 2=productie pe baza de retetar
	uchar  luna_lansarii;
	uchar  anul_lansarii;
	double sold_inceput_an;
	double sume[12];
	uchar  luna_inchiderii;
} artcd;
struct TABCD
{
	ulong  cod;
	ushort pozitia;
} *pcd,*qcd;
int fccd(void)
{
	PUN(TABCD)
	TESTR(cod)
	return 0;
}
void caut_cmd(ulong cod)
{
	stanga=-1;dreapta=nartcd;
	while(dreapta-stanga>1)
	{
		mijloc=(dreapta+stanga)>>1;
		pcd=qcd+mijloc;
		TEST(cod,pcd->cod)
		NEGASIT=0;LOC=mijloc;return;
	}
	NEGASIT=1;LOC=dreapta;
}
#endif

#ifdef DEF_CLIENTI
uchar nume_nomc[]="aaCLuuuu.HHH";
short nfc;
ulong RCSC,nartc;
struct CLIENTI
{
	ushort cod;
	uchar  den[40];
	uchar  judet[16];
	uchar  localitate[30];
	uchar  strada[30];
	uchar  numar[5];
	uchar  bloc[8];
	uchar  scara[5];
	uchar  etaj[3];
	uchar  apt[3];
	uchar  telefon_fix[20];
	uchar  telefon_mobil[20];
	uchar  cod_fiscal[13];
	uchar  nr_reg[15];
	uchar  banca[24];
	uchar  cont_bancar[24];
	uchar  contract[16];
	uchar  masina[16];
	uchar  delegat[24];
	uchar  serie_buletin[2];
	uchar  nr_buletin[8];
	uchar  politie[24];
	uchar  cod_agent;
	uchar  scadenta;
	uchar  selectie;
	uchar  sw_intern;
	uchar  adaos;
	ulong  cont;
	double sold;
	ushort cod_sortare;
} artc;
struct TABC
{
	ushort cod;
	ushort pozitia;
} *pnc,*qnc;
int fcnc(void)
{
	PUN(TABC)
	TESTR(cod)
	return 0;
}
void caut_cln(ushort cod)
{
	stanga=-1;dreapta=nartc;
	while(dreapta-stanga>1)
	{
		mijloc=(dreapta+stanga)>>1;
		pnc=qnc+mijloc;
		TEST(cod,pnc->cod)
		NEGASIT=0;LOC=mijloc;return;
	}
	NEGASIT=1;LOC=dreapta;
}
#endif

#ifdef DEF_FURNIZORI
uchar nume_nomf[]="aaFRuuuu.HHH";
short nff;
ulong RCSF;
long nartf;
struct FURNIZORI
{
	ushort cod;
	uchar  den[30];
	uchar  localitate[22];
	uchar  cod_fiscal[13];
	uchar  sw_intern;
	uchar  cod_selectie;
	ushort cod_sortare;
	ulong  cont;
} artf;
struct TABF
{
	ushort cod;
	ushort pozitia;
} *pnf,*qnf;
int fcnf(void)
{
	PUN(TABF)
	TESTR(cod)
	return 0;
}
void caut_furn(ushort cod)
{
	stanga=-1;dreapta=nartf;
	while(dreapta-stanga>1)
	{
		mijloc=(dreapta+stanga)>>1;
		pnf=qnf+mijloc;
		TEST(cod,pnf->cod);
		NEGASIT=0;LOC=mijloc;return;
	}
	NEGASIT=1;LOC=dreapta;
}
#endif

#ifdef CORECTIE
void corectie(uchar *ECRAN,uchar linii,uchar coloane)
{
	uchar i,j;
	for(i=0;i<linii;i++)
	{
		for(j=0;j<coloane;j++)
		{
			if(ECRAN[i*coloane+j]=='|') ECRAN[i*coloane+j]=0xB3;
			else if(ECRAN[i*coloane+j]=='-') ECRAN[i*coloane+j]=0xC4;
		}
	}
	ECRAN[0]=0xDA;
	ECRAN[coloane-1]=0xBF;
	ECRAN[(linii-1)*coloane+0]=0xC0;
	ECRAN[(linii-1)*coloane+coloane-1]=0xD9;
	for(i=1;i<linii-1;i++)
	{
		for(j=1;j<coloane-1;j++)
		{
			if(ECRAN[(i-1)*coloane+j]==0xB3
			&&ECRAN[(i+1)*coloane+j]==0xB3
			&&ECRAN[i*coloane+j-1]==0xC4
			&&ECRAN[i*coloane+j+1]==0xC4) ECRAN[i*coloane+j]=0xC5;
		}
	}
	for(i=0;i<linii;i++)
	{
		for(j=1;j<coloane-1;j++)
		{
			if(ECRAN[i*coloane+j]!=0xC4) continue;
			if(ECRAN[i*coloane+j-1]!=0xC4) continue;
			if(ECRAN[i*coloane+j+1]!=0xC4) continue;
			if(i&&ECRAN[(i-1)*coloane+j]!=0xB3) continue;
			if(i<(linii-1)&&ECRAN[(i-1)*coloane+j]!=0xB3) continue;
			if((!i||i&&ECRAN[(i-1)*coloane+j]<0x7F)
			&&(i==(linii-1)||i<(linii-1)&&ECRAN[(i+1)*coloane+j]==0xB3))
			{
				ECRAN[i*coloane+j]=0xC2;
				continue;
			}
			if((!i||i&&ECRAN[(i-1)*coloane+j]==0xB3)
			&&(i==(linii-1)||i<(linii-1)&&ECRAN[(i+1)*coloane+j]<0x7F))
			{
				ECRAN[i*coloane+j]=0xC1;
				continue;
			}
		}
	}
	for(i=1;i<linii-1;i++)
	{
		for(j=0;j<coloane;j++)
		{
			if(ECRAN[i*coloane+j]!=0xB3) continue;
			if(j<(coloane-1)&&ECRAN[i*coloane+j+1]==0xC4)
			{
				ECRAN[i*coloane+j]=0xC3;
				continue;
			}
			if(j&&ECRAN[i*coloane+j-11]==0xC4)
			{
				ECRAN[i*coloane+j]=0xB4;
				continue;
			}
		}
	}
	for(i=1;i<linii-1;i++)
	{
		for(j=1;j<coloane-1;j++)
		{
			if(ECRAN[(i-1)*coloane+j]<0x7F
			&&ECRAN[(i+1)*coloane+j]==0xB3) ECRAN[i*coloane+j]=0xC2;
		}
	}
}
#endif
